package com.hzs.retail.member.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.hzs.common.domain.retail.member.CuMemberRetailRegion;
import com.hzs.common.domain.retail.member.ext.CuMemberRetailRegionExt;
import com.hzs.common.domain.system.base.BdArea;
import com.hzs.retail.member.param.RetailMemberRegionParam;
import com.hzs.retail.member.vo.UnboundAreaVO;

import java.util.List;

/**
 * 新零售会员区域配置 服务类
 */
public interface ICuMemberRetailRegionService extends IService<CuMemberRetailRegion> {

    /**
     * 查询会员收益区域
     *
     * @param pkMember   会员ID
     * @param gradeValue 等级值
     * @param systemType 系统类型
     * @return
     */
    CuMemberRetailRegionExt getRegionByMember(Long pkMember, Integer gradeValue, Integer systemType);

    /**
     * 设置会员收益区域
     *
     * @param param 设置参数
     * @return
     */
    String setRegion(RetailMemberRegionParam param);

    /**
     * 可选择的收益区域
     *
     * @param systemType 系统类型
     * @return
     */
    List<BdArea> listChooseRegion(Integer systemType);

    /**
     * 未绑定收益区域
     **/
    List<UnboundAreaVO> unboundAreaList(Integer pkCountry, Integer systemType);

    /**
     * 查询会员收益区域
     **/
    List<CuMemberRetailRegionExt> memberretailRegList(CuMemberRetailRegionExt mrrExt);

    /**
     * 取消收益区域
     *
     * @param pkIdList 收益区域ID
     */
    void cancelRegion(List<Long> pkIdList);

    /**
     * 会员购买订单数量
     *
     * @param pkMember      会员ID
     * @param systemType    系统类型
     * @param waresCodeList 商品列表
     * @return
     */
    int getOrderCount(Long pkMember, Integer systemType, List<String> waresCodeList);


    int validateBindCount(CuMemberRetailRegionExt mrrExt, Integer yesOrNoValue, Integer systemType, Long pkId);

    int validateBindCount(RetailMemberRegionParam mrrExt, Integer yesOrNoValue, Integer systemType, Long pkId);

    Long getRegionVertexPkIdByPkMember(Long pkMember);
}
